[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]
Re: [Qemu-devel] [PATCH v7 2/6] docker: don't rely on submodules existin
From: |
Eric Blake |
Subject: |
Re: [Qemu-devel] [PATCH v7 2/6] docker: don't rely on submodules existing in the main checkout |
Date: |
Thu, 28 Sep 2017 13:03:41 -0500 |
User-agent: |
Mozilla/5.0 (X11; Linux x86_64; rv:52.0) Gecko/20100101 Thunderbird/52.3.0 |
On 09/28/2017 07:06 AM, Daniel P. Berrange wrote:
> When building the tarball to pass into the docker/vm test image,
> the code relies on the git submodules being checked out in the
> main checkout.
>
> ie if the developer has not run 'git submodule update --init dtc'
> many of the docker tests will fail due to the libfdt package not
'dtc' vs. 'libfdt' - is one of the acronyms wrong?
> being present in the test images. Patchew manually checks out the
> dtc submodule in the main git checkout, but this is a bad idea.
>
> When running tests we want to have a predictable set of submodules
> included in the source that's tested. The build environment is
> completely independant of the developers host OS, so the submodules
s/independant/independent/
> the developer has checked out should not be considered relevant for
> the tests.
>
> This changes the archive-source.sh script so that it clones the
> current git checkout into a temporary directory, checks out a
> fixed set of submodules, builds the tarball and finally removes
> the temporary git clone.
>
> Signed-off-by: Daniel P. Berrange <address@hidden>
> ---
> scripts/archive-source.sh | 30 +++++++++++++++++++++++++++---
> 1 file changed, 27 insertions(+), 3 deletions(-)
>
> +++ b/scripts/archive-source.sh
> +# We want a predictable list of submodules for builds, that is
> +# independant of what the developer currently has initialized
and again
> +# in their checkout, because the build environment is completely
> +# different to the host OS.
> +submodules="dtc"
>
> if test $? -ne 0; then
> error "git submodule command failed"
> @@ -28,6 +34,21 @@ fi
>
> trap "status=$?; rm -f \"$list_file\"; exit \$status" 0 1 2 3 15
>
> +if git diff-index --quiet HEAD -- &>/dev/null
> +then
> + HEAD=HEAD
> +else
> + HEAD=`git stash create`
> +fi
> +git clone --shared . "$vroot_dir"
set -e is not in effect; do you need error checking here?
> +here=`pwd`
$PWD is cheaper than spawning a subprocess for `pwd`.
> +cd "$vroot_dir"
Definitely need error checking here.
> +git checkout $HEAD
> +
> +for sm in $submodules; do
> + git submodule update --init $sm
> +done
> +
> if test -n "$submodules"; then
> {
> git ls-files || error "git ls-files failed"
> @@ -48,4 +69,7 @@ fi
>
> tar -cf "$tar_file" -T "$list_file" || error "failed to create tar file"
>
> +cd "$here"
and again here
> +rm -rf "$vroot_dir"
> +
> exit 0
>
--
Eric Blake, Principal Software Engineer
Red Hat, Inc. +1-919-301-3266
Virtualization: qemu.org | libvirt.org
signature.asc
Description: OpenPGP digital signature
- [Qemu-devel] [PATCH v7 0/6] Initial support for keycodemapdb GIT submodule, Daniel P. Berrange, 2017/09/28
- [Qemu-devel] [PATCH v7 1/6] build: automatically handle GIT submodule checkout for dtc, Daniel P. Berrange, 2017/09/28
- [Qemu-devel] [PATCH v7 2/6] docker: don't rely on submodules existing in the main checkout, Daniel P. Berrange, 2017/09/28
- Re: [Qemu-devel] [PATCH v7 2/6] docker: don't rely on submodules existing in the main checkout,
Eric Blake <=
- [Qemu-devel] [PATCH v7 3/6] ui: add keycodemapdb repository as a GIT submodule, Daniel P. Berrange, 2017/09/28
- [Qemu-devel] [PATCH v7 5/6] ui: convert key events to QKeyCodes immediately, Daniel P. Berrange, 2017/09/28
- [Qemu-devel] [PATCH v7 6/6] ui: don't export qemu_input_event_new_key, Daniel P. Berrange, 2017/09/28
- [Qemu-devel] [PATCH v7 4/6] ui: convert common input code to keycodemapdb, Daniel P. Berrange, 2017/09/28
- Re: [Qemu-devel] [PATCH v7 0/6] Initial support for keycodemapdb GIT submodule, no-reply, 2017/09/28